#include <stdlib.h>  

#include <GL/glut.h>
 
void  display (void)
{
	GLfloat tetra[4][3]={
		{ 100.0f, 100.0f, 100.f},
		{-100.0f,-100.0f, 100.f},
		{ 100.0f,-100.0f,-100.f},
		{-100.0f, 100.0f,-100.f}
	};

	static GLfloat p[2]={75.0f,75.0f};
	int i, j;

    glClear (GL_COLOR_BUFFER_BIT);
	
	glMatrixMode (GL_MODELVIEW);    /*  back to modelview matrix    */
	glLoadIdentity ();  
	glTranslatef(0,0,-1000); /* Translate the gasket down the -z axis */

	glBegin(GL_POINTS);
		
	for(j=0;j<20000;j++)
	{
		i=rand()%4;
		
		p[0]=(p[0]+tetra[i][0])/2.0f;
		p[1]=(p[1]+tetra[i][1])/2.0f;
		p[2]=(p[2]+tetra[i][2])/2.0f;
		
		glVertex3fv(p);
	}
	glEnd();
	
	glFlush();
}

void  myinit (void) {
	glClearColor (0.0, 0.0, 0.0, 0.0);
    }

/*  Called when the window is first opened and whenever 
 *  the window is reconfigured (moved or resized).
 */
void  reshape(GLsizei w, GLsizei h)
{
	glMatrixMode (GL_PROJECTION);   /*  prepare for and then  */ 
	glLoadIdentity ();  /*  define the projection  */
	gluPerspective(30.0,(float)w/(float)h,500,10000);
	glViewport (0, 0, (GLsizei) w, (GLsizei) h); 
	glMatrixMode (GL_MODELVIEW);    /*  back to modelview matrix    */
}

/*  Main Loop
 *  Open window with initial window size, title bar, 
 *  RGBA display mode, and handle input events.
 */
int main(int argc, char** argv)
{
    glutInit(&argc, argv);
    glutInitDisplayMode (GLUT_SINGLE| GLUT_RGB);
    glutInitWindowSize(400, 400);
    glutInitWindowPosition (10, 10);

    glutCreateWindow (argv[0]);
 	glutDisplayFunc(display);
	glutReshapeFunc(reshape); 
	
	myinit();
	glutMainLoop();
	return(0);
}
